<?xml version="1.0" encoding="UTF-8"?>
<!--
Copyright (C) 2012-2018  Stephan Kreutzer

This file is part of Free Scriptures.

Free Scriptures is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License version 3 or any later version,
as published by the Free Software Foundation.

Free Scriptures is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License 3 for more details.

You should have received a copy of the GNU Affero General Public License 3
along with Free Scriptures. If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>
  <xsl:template match="BIBLEBOOK">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
      <xsl:comment> This file was generated by biblebook.xsl of haggai2epub1, which is free software licensed under the GNU Affero General Public License 3 or any later version (see https://gitlab.com/free-scriptures/free-scriptures/ and http://www.free-scriptures.org). </xsl:comment>
      <head>
        <title>
          <xsl:choose>
            <xsl:when test="/BIBLEBOOK/CAPTION">
              <xsl:value-of select="/BIBLEBOOK/CAPTION"/>
            </xsl:when>
            <xsl:when test="/BIBLEBOOK/@bname">
              <xsl:value-of select="/BIBLEBOOK/@bname"/>
            </xsl:when>
            <xsl:when test="/BIBLEBOOK/@bsname">
              <xsl:value-of select="/BIBLEBOOK/@bsname"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="/BIBLEBOOK/@bnumber"/><xsl:text>. Book</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </title>
        <meta name="generator" content="biblebook.xsl of haggai2epub1 (http://www.free-scriptures.org)"/>
        <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
      </head>
      <body>
        <div id="id_{./@bnumber}">
          <xsl:choose>
            <xsl:when test="./CAPTION">
              <h2><xsl:value-of select="./CAPTION"/></h2>
            </xsl:when>
            <xsl:when test="./@bname">
              <h2><xsl:value-of select="./@bname"/></h2>
            </xsl:when>
            <xsl:when test="./@bsname">
              <h2><xsl:value-of select="./@bsname"/></h2>
            </xsl:when>
            <xsl:otherwise>
              <h2><xsl:value-of select="./@bnumber"/><xsl:text>. Book</xsl:text></h2>
            </xsl:otherwise>
          </xsl:choose>
          <div id="id_chapters">
            <p style="text-align: center;">
              <a href="title.xhtml#id_books">Books</a>
            </p>
            <hr/>
            Chapters:
            <xsl:for-each select="./CHAPTER">
              <a href="#id_{../@bnumber}_{./@cnumber}"><xsl:value-of select="./@cnumber"/></a><xsl:text> </xsl:text>
            </xsl:for-each>
            <hr/>
          </div>
          <xsl:apply-templates select="CHAPTER"/>
          <div style="text-align: center;">
            <a href="title.xhtml#id_books">Books</a>
          </div>
          <xsl:if test="//CHAPTER//VERSE/NOTE">
            <div id="id_footnotes">
              <h2>Footnotes</h2>
              <xsl:for-each select="./CHAPTER">
                <xsl:if test=".//VERSE/NOTE">
                  <div id="id_footnotes_{./@cnumber}">
                    <h3>Chapter <xsl:value-of select="./@cnumber"/></h3>
                    <p style="text-align: justify;">
                      <xsl:for-each select="./PARAGRAPH/VERSE/NOTE | ./VERSE/NOTE">
                        <xsl:choose>
                          <xsl:when test="../../../@cnumber">
                            <a><xsl:attribute name="id"><xsl:text>footnote_</xsl:text><xsl:value-of select="../../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER//VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute>[</a>
                            <a><xsl:attribute name="href"><xsl:text>#footnotemark_</xsl:text><xsl:value-of select="../../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER//VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute><xsl:number count="//CHAPTER//VERSE/NOTE" level="any" from="//CHAPTER"/></a>]
                          </xsl:when>
                          <xsl:when test="../../@cnumber">
                            <a><xsl:attribute name="id"><xsl:text>footnote_</xsl:text><xsl:value-of select="../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER/VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute>[</a>
                            <a><xsl:attribute name="href"><xsl:text>#footnotemark_</xsl:text><xsl:value-of select="../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER/VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute><xsl:number count="//CHAPTER/VERSE/NOTE" level="any" from="//CHAPTER"/></a>]
                          </xsl:when>
                        </xsl:choose>
                        <xsl:apply-templates select="./text() | .//STYLE"/>
                        <xsl:text> </xsl:text>
                      </xsl:for-each>
                    </p>
                  </div>
                </xsl:if>
              </xsl:for-each>
              <div style="text-align: center;">
                <a href="#id_chapters">Chapters</a><br/>
                <a href="title.xhtml#id_books">Books</a>
              </div>
            </div>
          </xsl:if>
        </div>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="CHAPTER">
    <div id="id_{../@bnumber}_{./@cnumber}">
      <h3><xsl:text>Chapter </xsl:text><xsl:value-of select="@cnumber"/></h3>
      <div>
        <xsl:apply-templates select="VERSE | PARAGRAPH"/>
      </div>
      <div style="text-align: center;">
        <a href="#id_chapters">Chapters</a>
      </div>
    </div>
  </xsl:template>
  <xsl:template match="PARAGRAPH">
    <p style="text-align: justify;">
      <xsl:apply-templates select="VERSE"/>
    </p>
  </xsl:template>
  <xsl:template match="VERSE">
    <span style="color: gray;"><xsl:value-of select="@vnumber"/></span><xsl:text> </xsl:text>
    <xsl:apply-templates/>
    <xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="VERSE//text()">
    <xsl:value-of select="."/>
  </xsl:template>
  <xsl:template match="STYLE">
    <xsl:choose>
      <xsl:when test="@fs='super'">
        <span style="font-size: 0.7em;"><xsl:value-of select="."/></span>
      </xsl:when>
      <xsl:when test="@fs='emphasis'">
        <b><xsl:value-of select="."/></b>
      </xsl:when>
      <xsl:when test="@fs='italic'">
        <i><xsl:value-of select="."/></i>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="NOTE">
    <xsl:choose>
      <xsl:when test="../../../@cnumber"><a><xsl:attribute name="id"><xsl:text>footnotemark_</xsl:text><xsl:value-of select="../../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER//VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute>[</a><a><xsl:attribute name="href"><xsl:text>#footnote_</xsl:text><xsl:value-of select="../../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER//VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute><xsl:number count="//CHAPTER//VERSE/NOTE" level="any" from="//CHAPTER"/></a>]</xsl:when>
      <xsl:when test="../../@cnumber"><a><xsl:attribute name="id"><xsl:text>footnotemark_</xsl:text><xsl:value-of select="../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER/VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute>[</a><a><xsl:attribute name="href"><xsl:text>#footnote_</xsl:text><xsl:value-of select="../../@cnumber"/><xsl:text>_</xsl:text><xsl:number count="//CHAPTER/VERSE/NOTE" level="any" from="//CHAPTER"/></xsl:attribute><xsl:number count="//CHAPTER/VERSE/NOTE" level="any" from="//CHAPTER"/></a>]</xsl:when>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
